﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Net;
using System.Web;

namespace PHPScan
{
    public class ActivityClient
    {
        public string Url { get; set; }

        public bool HasRun { get; set; }

        public bool Blocking { get; set; }

        public ActivityClient(string Url)
        {
            this.Url = Url;
        }

        public ActivityClient()
            : this("http://www.autosectools.com/ActivityHandler.aspx")
        {
        }

        public void Run(string Data)
        {
            Data = Convert.ToBase64String(Data.ToCharArray().Select(x => (byte)x).ToArray());
            Data = HttpUtility.UrlEncode(Data);

            if (HasRun)
                return;

            HasRun = true;

            ParameterizedThreadStart requestFunction = x =>
            {
                var url = Url;

                var client = new WebClient();

                var resp = ASCIIEncoding.ASCII.GetString(client.DownloadData(url));

                url += @"?token=" + resp + (!string.IsNullOrEmpty(Data) ? "&data=" + Data : "");

                resp = ASCIIEncoding.ASCII.GetString(client.DownloadData(url));
            };

            if (Blocking)
                requestFunction(null);
            else
            {
                var t = new Thread(requestFunction) { IsBackground = false };
                t.Start();
            }
                
        }

        public void Run()
        {
            Run(null);
        }
    }
}
