﻿using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PHPScan
{
    public class FilenameInfo
    {
        public string File { get; set; }
        public bool HasExtension { get; set; }
        public string Extension { get; set; }

        public static FilenameInfo FromFileInfo(FileInfo FileInfo)
        {
            var extensionIndex = FileInfo.Name.LastIndexOf(".");

            var name = FileInfo.Name.Remove(extensionIndex);

            return extensionIndex != -1 ?
                new FilenameInfo(name, FileInfo.Name.Substring(extensionIndex + 1)) :
                new FilenameInfo() { File = name };
        }

        public FilenameInfo() { }

        public FilenameInfo(string File, string Extension)
        {
            this.File = File;
            this.HasExtension = true;
            this.Extension = Extension;
        }

        public override string ToString()
        {
            return HasExtension ? File + "." + Extension : File;
        }
    }
}
