﻿using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace PHPScan
{
    public class FunctionHookCollection : List<FunctionHook>
    {
        public void CreateHookFile()
        {
            var functions = new StringBuilder("<?php ");

            //functions.Append("error_reporting(0);");

            foreach (FunctionHook h in this)
                functions.AppendLine(h.ReplacementFunction);

            functions.Append(Properties.Resources.SuperGlobalOverride);

            functions.Append(" ?>");

            File.WriteAllText(Program.Config.WebRoot + "\\" + FunctionHook.HookFileName,
                functions.ToString());
        }

        public void DeleteHookFile()
        {
            File.Delete(Program.Config.WebRoot + "\\" + FunctionHook.HookFileName);
        }

        public void HookDirectory(DirectoryInfo Directory)
        {
            var files = Directory.GetFiles().Where(x =>
                x.Extension.ToLower() == ".php" ||
                x.Extension.ToLower() == ".inc");

            foreach (FileInfo f in files)
            {
                var backup = Directory.GetFiles(f.Name + "b");

                if (backup.Length != 0)
                    try
                    {
                        backup[0].CopyTo(f.FullName, true);
                    }
                    catch (UnauthorizedAccessException ex)
                    {
                        Console.WriteLine("\r\n\r\nError hooking file\r\n{0}\r\n",
                            ex.Message);

                        continue;
                    }                    
                else
                    f.CopyTo(f.FullName + "b", true);

                string php = File.ReadAllText(f.FullName);

                
                //php = PreloadHelper.PatchArrayFunctions(php);
                php = PreloadHelper.Patch(php);

                

                //var strings = StringParser.GetStrings(php, true);

                //var stringReplacements = strings
                //    .Select(x => PHPPatcher.PatchStringSuperGlobals(x))
                //    .ToArray();

                //for (int i = 0; i < strings.Length; i++)
                //    php = php.Replace(strings[i], stringReplacements[i]);

                foreach (FunctionHook h in this)
                    h.Hook(ref php);

                

                var phpRegex = @"\<\?(php)?";

                //string include = " if(!class_exists(FernDebug))require($_SERVER['DOCUMENT_ROOT'] . '/" +
                //    FunctionHook.HookFileName + "');";

                //string include = " if(!class_exists('FernDebug',false))require('" +
                string include = " require_once('" +
                    Program.Config.WebRoot.Replace('\\', '/') + "/" + FunctionHook.HookFileName + "');";                

                try
                {
                    var m = Regex.Match(php, phpRegex, RegexOptions.IgnoreCase);

                    if (m.Success)
                        php = php.Insert(m.Index + m.Length, include);

                    //php = php.Insert(m.Index +
                    //    phpRegex.Length - 2, include);
                }
                catch
                {
                    Console.WriteLine("\r\nError inserting include into " + f.FullName);
                }

                php = ScanMetrics.Default.AnnotateCode(f.FullName, php);

                try
                {
                    File.WriteAllText(f.FullName, php);
                }
                catch (UnauthorizedAccessException ex)
                {
                    Console.WriteLine("\r\n\r\nError hooking file\r\n{0}\r\n",
                        ex.Message);

                    continue;
                }                    
                

                Console.Write(".");
            }

            var subDirs = Directory.GetDirectories();

            foreach (DirectoryInfo d in subDirs)
                HookDirectory(d);            
        }

        public void UnhookDirectory(DirectoryInfo Directory)
        {
            var files = Directory
                .GetFiles("*.*")
                .Where(x => x.Extension == ".php" || x.Extension == ".inc");

            foreach (FileInfo f in files)
            {
                try
                {
                    IO.TryAction(() =>
                    {
                        var backup = Directory.GetFiles(f.Name + "b");

                        if (backup.Length != 0)
                        {
                            backup[0].CopyTo(f.FullName, true);
                            backup[0].Delete();
                        }
                    });

                    Console.Write(".");                
                }
                catch (System.Exception ex)
                {
                    Console.WriteLine("\r\nError unhooking {0}:\r\n{1}\r\n\r\n",
                        f.FullName, ex.Message);
                }                
            }

            foreach (DirectoryInfo d in Directory.GetDirectories())
                UnhookDirectory(d);
        }
    }
}
