﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace PHPScan
{
    public static class PHP
    {
        public static readonly string[] Superglobals = new[]
        {
            "$_GET",
            "$_POST",
            "$_REQUEST",
            "$_FILES",
            "$_COOKIE",
        };

        public const string NonNameStartRegex = @"([^a-zA-Z_\x7f-\xff])";
        public const string NonNameEndRegex = @"([^a-zA-Z0-9_\x7f-\xff])";
        public const string ValidNameRegex = @"[a-zA-Z_\x7f-\xff][a-zA-Z0-9_\x7f-\xff]*";

        public static string CreateNameRegex(string Name)
        {
            return NonNameStartRegex + Name + NonNameEndRegex;
        }

        public static string ReplaceName(string Name, string Replacement, string Code)
        {
            var nameRegex = CreateNameRegex(Name);

            return Regex.Replace(Code, nameRegex, "$1" + Replacement + "$2");
        }

        public static string Override(string Code, params string[] Names)
        {
            foreach (var name in Names)
                Code = ReplaceName(name, name + "_override", Code);

            return Code;
        }
    }
}
