﻿using System;
using System.IO;
using System.Security.Cryptography;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Net.Sockets;
using PHPScan.ScanAlgorithms;
using System.Reflection;
using System.Security.Principal;
using System.Threading;

namespace PHPScan
{
    class Program
    {
        public static ScanConfig Config;

        public static string traceFileName = null;

        static bool hook = true, scan = true;

        static ActivityClient _client = new ActivityClient() { Blocking = true };

        static ManualResetEvent _clientReset = new ManualResetEvent(false);

        static void SendRequest()
        {
            ThreadPool.QueueUserWorkItem(x =>
            {
                try
                {
                    var data = string.Format(@"PHP Vulnerability Hunter {0}
{1}",
                        Assembly.GetExecutingAssembly().GetName().Version,
                        Environment.CommandLine);
                    _client.Run(data);
                }
                //catch (System.Exception ex)
                //{

                //}
                finally
                {
                    _clientReset.Set();
                }
            });
        }

        public static void Exit()
        {
            _clientReset.WaitOne();
            Console.ResetColor();
            Environment.Exit(0);
        }       

        static void Main(string[] args)
        {
//            var s  = PreloadHelper.PatchArrayTyping(@"
//
//function blah(array $var, array $var2) {
//$var2 = array(1, 2, 3, 4);
//}
//
//// Initalise alert array
//$notify = array (
//	'type' => array(),
//	'message' => array()
//);
//
//");

            UI.RunAssistant();                
            UI.SetColors();
            UI.DisplayAppInfo();

            if (args.Length == 0)
            {
                UI.DisplayInstructions();

                SendRequest();

                UI.Pause();

                Exit();
            }            

            SendRequest();

            Config = ScanConfig.Create(args);

            traceFileName = Config.WebRoot + @"\trace.txt";

            foreach (var algorithm in Config.ScanAlgorithms
                .OfType<FileScanAlgorithm>())
                algorithm.StartWatching(new DirectoryInfo(Config.WebRoot).Root.ToString());

            foreach (string RelativeAppPath in Config.ApplicationPaths)
            {
                

                UI.DisplayAppPath(RelativeAppPath);
                

                string filePath = Config.WebRoot + "\\" + RelativeAppPath.Replace('/', '\\');

                if (!Directory.Exists(filePath))
                {
                    UI.DisplayCriticalMessage("Application path {0} not found.", filePath);

                    Exit();
                }

                ScanMetrics.Default = new ScanMetrics()
                {
                    AnnotationFile = new FileInfo(Config.WebRoot + "\\Annotation.txt")
                };                

                #region Hooks
                var hooks2 = new FunctionHookCollection()
                {
                    //new FunctionHook("mysql_query", 2),


                    //new FunctionHook("include", 1),
                    //new FunctionHook("require", 1),
                    //new FunctionHook("require_once", 1),

                    //new FunctionHook("include", 1, DelimiterOptions.None),
                    //new FunctionHook("require", 1, DelimiterOptions.None),
                    //new FunctionHook("require_once", 1, DelimiterOptions.None),

                    new FunctionHook("eval", 1),

                    new FunctionHook("system", 1),
                    new FunctionHook("system", 2),
                    
                    new FunctionHook("exec", 1),
                    new FunctionHook("exec", 2),
                    new FunctionHook("exec", 3),

                    new FunctionHook("shell_exec", 1),

                    new FunctionHook("passthru", 1),
                    new FunctionHook("passthru", 2),

                    //new FunctionHook("copy", 3),
                    //new FunctionHook("file_get_contents", 5),
                    //new FunctionHook("file_put_contents", 4),
                    //new FunctionHook("file", 3),
                    //new FunctionHook("fopen", 4),
                    //new FunctionHook("fputs", 3),
                    //new FunctionHook("fread", 2),
                    //new FunctionHook("fwrite", 3),
                    new FunctionHook("move_uploaded_file", 2),
                    new FunctionHook("mysql_query", 1),
                    new FunctionHook("mysql_query", 2),
                    //new FunctionHook("parse_ini_file", 3),
                    //new FunctionHook("parse_ini_string", 3),
                    //new FunctionHook("popen", 2),
                    //new FunctionHook("readfile", 3),                

                    
                    //new FunctionHook("system", 2),

                    //new FunctionHook("header", 3),
                    

                    //new FunctionHook("$_SERVER", 1, DelimiterOptions.Brackets),
                    new FunctionHook("$_FILES", 1, DelimiterOptions.Brackets),
                    //new FunctionHook("$_GET", 1, DelimiterOptions.Brackets),
                    //new FunctionHook("$_POST", 1, DelimiterOptions.Brackets),
                    //new FunctionHook("$_REQUEST", 1, DelimiterOptions.Brackets),
                    //new FunctionHook("$_COOKIE", 1, DelimiterOptions.Brackets),
                };
                #endregion

                if (hook)
                {
                    Console.Write("Hooking");
                    hooks2.HookDirectory(new DirectoryInfo(filePath));
                    hooks2.CreateHookFile();
                    Console.WriteLine();
                }

                if (scan)
                {
                    ScanDirectory(new DirectoryInfo(filePath), RelativeAppPath);
                    Console.WriteLine("\r\nScan complete\r\n");
                }

                // Cleanup
                hooks2.DeleteHookFile();

                File.Delete(traceFileName);

                var lfi = Config.ScanAlgorithms
                    .OfType<LocalFileInclusionScanAlgorithm>()
                    .FirstOrDefault();

                if (lfi != null)
                    lfi.DeleteTxtFile();

                if (Config.Unhook)
                {
                    Console.Write("Unhooking");
                    hooks2.UnhookDirectory(new DirectoryInfo(filePath));

                    foreach (FileScanAlgorithm f in Config.ScanAlgorithms.Where(x =>
                        x is FileScanAlgorithm))
                        f.FsArgs = null;

                    Console.WriteLine("\r\n");
                }
            }


            UI.Pause();
        }

        static string[] CreateUrls(string RelativeAppPath, DirectoryInfo AppDirectory)
        {
            return AppDirectory
                .GetFiles("*.php", SearchOption.AllDirectories)
                .Select(x => System.Web.HttpUtility.UrlPathEncode("/" + RelativeAppPath + "/" +
                    x.FullName.Remove(0, AppDirectory.FullName.Length + 1).Replace('\\', '/')))
                .ToArray();
                
            //foreach (FileInfo f in files.Where(x => x.Extension == ".php"))
            //    {
            //        var remotePath = "/" + serverPath + "/" +
            //            f.FullName.Remove(0, Directory.FullName.Length + 1).Replace('\\', '/');

            //        remotePath = System.Web.HttpUtility.UrlPathEncode(remotePath);
        }

        

        static void ScanDirectory(DirectoryInfo AppDirectory, string RelativeAppPath)
        {
            //serverPath = System.Web.HttpUtility.UrlEncode(serverPath);

            var ignoreExtensions = new[]
            {
                "png",
                "jpg",
                "jpeg",
                "gif",
                "ico",
                "js",
                "css",
            };

            var urlCollections = new[]
            {
                CreateUrls(RelativeAppPath, AppDirectory).ToList(),
                new List<string>()
            };


            //var files = AppDirectory
            //    .GetFiles("*", SearchOption.AllDirectories)
            //    .Where(x => x.Extension == ".php" || x.Extension == ".inc");

            //var traces = new List<FileTrace>();

            //var traceTable = new Dictionary<ScanAlgorithm, Dictionary<int, Dictionary<string, FileTrace>>>();
            var traceTable = new TraceTable();

            var report = new StringBuilder();

            var coverageReport = new StringBuilder();

            var alerts = new ScanAlertCollection();

            int requestCount = 0;

            MessageDumper messageDumper = null;

            if (Config.DumpMessages)
                messageDumper = new MessageDumper();

            for (int urlCollectionIndex = 0; urlCollectionIndex < 2; urlCollectionIndex++)
            foreach (ScanAlgorithm scanAlgorithm in Config.ScanAlgorithms)
            {
                ScanMetrics.Default.Reset();

                if (!urlCollections[urlCollectionIndex].Any())
                    continue;

                UI.DisplayScanAlgorithm(scanAlgorithm);                
                
                foreach (var remotePath in urlCollections[urlCollectionIndex])
                {
                    UI.DisplayResourcePath(remotePath);
                    
                    for (int i = 0; i < scanAlgorithm.ModeCount; i++)
                    {
                        var trace = new FileTrace();                        

                        
                        //Console.ForegroundColor = ConsoleColor.White;

                        bool discoveredVars = true;

                        while (discoveredVars)
                        {
                            var traceFile = new FileInfo(traceFileName);

                            IO.TryAction(traceFile.Delete);

                            var client = new TcpClient()
                            {
                                ReceiveTimeout = 8000,
                                SendTimeout = 8000
                            };

                            client.Connect(Config.Server, 80);
                            client.LingerState = new LingerOption(true, 0);

                            HttpResponse resp = null;

                            string req, respString = "";

                            using (var stream = client.GetStream())
                            {
                                req = scanAlgorithm.BuildRequest(i, remotePath, trace);

                                if (Config.DumpMessages)
                                    messageDumper.Dump(req, requestCount, MessageType.Request);
                                
                                stream.WriteString(req);

                                
                                try
                                {
                                    var reader = new HttpResponseReader(stream);
                                    resp = reader.Read();
                                    respString = resp.CompleteResponse;

                                    UI.DisplayResponse(resp);
                                }
                                catch (System.Net.Sockets.SocketException ex)
                                {
                                    UI.DisplayResponseError(respString);
                                }
                                catch (System.IO.IOException ex)
                                {
                                    UI.DisplayResponseError(respString);
                                }

                                //stream.Close();
                            }

                            if (urlCollectionIndex == 0 && resp != null)
                            {
                                var urls = new UriParser()
                                {
                                    TargetHost = Config.Server,
                                }.Parse(resp.Body);

                                foreach (var url in urls)
                                {
                                    if (!ignoreExtensions.Any(x => url.ToLower().EndsWith("." + x)) &&
                                        !urlCollections[0].Contains(url) &&
                                        !urlCollections[1].Contains(url))
                                        urlCollections[1].Add(url);
                                }
                            }
                            else
                                Console.Write("");

                            
                            client.Close();

                            if (Config.DumpMessages)
                                messageDumper.Dump(respString, requestCount, MessageType.Response);

                            requestCount++;

                            string traceText = "";

                            traceFile = new FileInfo(traceFileName);

                            FileTrace newTrace = null;

                            IO.TryAction(() =>
                            {
                                //if (traceFile.Exists)
                                //    using (var reader = traceFile.OpenText())
                                //        traceText = reader.ReadToEnd();

                                if (traceFile.Exists)
                                    using (var reader = traceFile.OpenText())
                                        newTrace = FileTrace.Parse(reader);
                            });

                            //var newTrace = FileTrace.Parse(traceText);

                            if (newTrace == null)
                                newTrace = new FileTrace();
                            newTrace.Request = req;
                            newTrace.Response = respString;
                            newTrace.File = remotePath;

                            var alert = scanAlgorithm.ScanTrace(newTrace);

                            //if (alert != null &&
                            //    alerts.Count(x => x.Trace.RawText == alert.Trace.RawText) == 0)
                            if (alert != null)
                            {
                                if (Config.BeepOnAlert)
                                    Console.Beep();

                                UI.DisplayAlert(alert);

                                alerts.Add(alert);
                                report.Append(alert.ToString());                                
                            }

                            discoveredVars = false;

                            //if (newTrace.Calls.Count < trace.Calls.Count)
                            //    throw new InvalidOperationException();

                            //if (newTrace.Calls.Count > trace.Calls.Count)
                            //    discoveredVars = true;
                            //else if (newTrace.Calls.Count == 0)
                            //    discoveredVars = false;
                            //else
                                foreach (FunctionCall c in newTrace.Calls
                                    .Superglobals())
                                {
                                    //var oldCalls = trace.Calls.Where(x =>
                                    //    x.Name == c.Name);

                                    var oldCalls = trace.Calls.Where(x =>
                                        x.Name == c.Name &&
                                        x.ParameterValues.SequenceEqual(c.ParameterValues));

                                    //if (oldCalls.Count() == 0 ||
                                    //    oldCalls.Count(x => x.Value == c.Value) == 0)
                                    if (!oldCalls.Any())
                                    {
                                        discoveredVars = true;
                                        break;

                                        //trace.Calls.Add(c);
                                    }
                                    else
                                        Console.Write("");
                                }

                                

                            var orphanedInputs = trace.Calls
                                .Superglobals()
                                .Where(x => !newTrace.Calls
                                    .Any(y => x.Name == y.Name && x.ParameterValues
                                        .SequenceEqual(y.ParameterValues)))
                                .ToArray();

                            


                            if (orphanedInputs.Any() && discoveredVars)
                                Console.Write("");

                            newTrace.Calls.AddRange(orphanedInputs);

                            trace = newTrace;
                        }

                        if (Config.DiscoveryReport)
                        {
                            if (!traceTable.ContainsKey(scanAlgorithm))
                                traceTable.Add(scanAlgorithm, new Dictionary<int, Dictionary<string, FileTrace>>());

                            if (!traceTable[scanAlgorithm].ContainsKey(i))
                                traceTable[scanAlgorithm].Add(i, new Dictionary<string, FileTrace>());

                            if (!traceTable[scanAlgorithm][i].ContainsKey(trace.File))
                                traceTable[scanAlgorithm][i].Add(trace.File, trace);
                            else
                                traceTable[scanAlgorithm][i][trace.File] = trace;
                        }

                        //traces.Add(t);
                    }
                }

                if (urlCollectionIndex == 0)
                {
                    CodeCoverageTable coverage = null;

                    IO.TryAction(() =>
                    {
                        coverage = ScanMetrics.Default.CalculateCoverage();
                    });

                    coverageReport.AppendLine(scanAlgorithm.ToString());
                    coverageReport.AppendLine(coverage.ToString() + "\r\n");
                }
            }

            Report.Write(RelativeAppPath, "Vulnerability Report", report.ToString());
            Report.Write(RelativeAppPath, "Code Coverage Report", coverageReport.ToString());
            

            if (alerts.Any())
            {
                var path = Report.GetUniqueReportName(RelativeAppPath, "Vulnerability Report",
                    "pxml");
                alerts.Save(path);

                if (Config.RunViewer)
                    System.Diagnostics.Process.Start(Assembly.GetExecutingAssembly().Location.RemoveAtLastIndexOf('\\', 1) +
                        @"PHPVHReportViewer.exe", "\"" + path + "\"");
            }                

            if (Config.DiscoveryReport)
                Report.Write(RelativeAppPath, "Scan Overview Report",
                    DiscoveryReport.Create(traceTable));
        }
    }
}
