﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace PHPScan
{
    public class UriParser
    {
        public string TargetHost { get; set; }

        public string[] Parse(string html)
        {
            //var r = @"(https://|http://|[^\w<]/|[^\w<]\\)([a-zA-Z\-\.]+)([/a-zA-Z0-9_\-%\.]+)(\?[a-zA-Z0-9_\-%&=]+)?";
            var r = @"(https://|http://|[^\w<]/)([a-zA-Z\-\.]+)([/a-zA-Z0-9_\-%\.]+)(\?[a-zA-Z0-9_\-%&=]+)?";
            //var r = @"(https://|http://)([a-zA-Z\-\.]+)([/a-zA-Z0-9_\-%]+)(\?[a-zA-Z0-9_\-%&=]+)?";

            var matches = Regex.Matches(html, r);

            return matches
                .OfType<Match>()
                .Where(x => !x.Value.StartsWith("http") ||
                    x.Value.Contains(TargetHost))
                .Select(x => x.Value.StartsWith("http") ?
                    "/" + new Uri(x.Value).GetComponents(UriComponents.Path, 
                        UriFormat.SafeUnescaped) :
                    x.Value.Substring(1)) 
                .Select(x => x.Contains("?") ? x.RemoveAtIndexOf('?') : x)
                .Distinct()
                .ToArray();
        }
    }
}
