﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Windows;
using AutoSecTools.Components.Wpf;
using PHPScan;

namespace PHPVHReportViewer.ViewModels
{
    public class ScanViewModel : BaseViewModel
    {
        private ObservableCollection<AlertViewModel> _Alerts;
        
        public ObservableCollection<AlertViewModel> Alerts
        {
        	get { return _Alerts; }
        	set
        	{                
        		_Alerts = value;
        
        		InvokePropertyChanged("Alerts");
        	}
        }

        private AlertViewModel _CurrentAlert;

        public AlertViewModel CurrentAlert
        {
            get { return _CurrentAlert; }
            set
            {
                _CurrentAlert = value;

                InvokePropertyChanged("CurrentAlert");
            }
        }

        public ScanViewModel(FrameworkElement Element, BaseViewModel Parent)
            : base(Element, Parent)
        {
        }

        public ScanViewModel(FrameworkElement Element)
            : base(Element)
        {
            
        }

        public ScanViewModel()
            : base()
        {
        }

        public void CreateAlertViewModels(IEnumerable<ScanAlert> ScanAlerts)
        {
            Alerts = new ObservableCollection<AlertViewModel>(ScanAlerts.Select(x => new AlertViewModel(x)));


            CurrentAlert = Alerts.First();
        }
    }
}
